Index: /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 253)
@@ -0,0 +1,792 @@
+      program rcm1d
+
+      use radcommon_h, only: tauvis
+! to use  'getin'
+      use ioipsl_getincom 
+
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Run the physics package of the universal model in a 1D column.
+!     
+!     It can be compiled with a command like (e.g. for 25 layers):
+!                                  "makegcm -p std -d 25 rcm1d"
+!     It requires the files "callphys.def", "z2sig.def",
+!     "traceur.def", and "run.def" with a line "INCLUDEDEF=callphys.def"
+!
+!     Authors
+!     -------
+!     Frederic Hourdin
+!     R. Fournier
+!     F. Forget
+!     F. Montmessin (water ice added)
+!     R. Wordsworth
+!
+!==================================================================
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comgeomfi.h"
+#include "surfdat.h"
+#include "comsoil.h"
+#include "comdiurn.h"
+#include "callkeys.h"
+#include "comcstfi.h"
+#include "planete.h"
+#include "comsaison.h"
+#include "control.h"
+#include "comvert.h"
+#include "netcdf.inc"
+#include "comg1d.h"
+#include "watercap.h" 
+#include "fisice.h"
+#include "logic.h"
+#include "advtrac.h"
+
+c --------------------------------------------------------------
+c  Declarations
+c --------------------------------------------------------------
+c
+      INTEGER unitstart      ! unite d'ecriture de "startfi"
+      INTEGER nlayer,nlevel,nsoil,ndt
+      INTEGER ilayer,ilevel,isoil,idt,iq
+      LOGICAl firstcall,lastcall
+c
+      INTEGER day0          ! date initial (sol ; =0 a Ls=0)
+      REAL day           ! date durant le run
+      REAL time             ! time (0<time<1 ; time=0.5 a midi)
+      REAL play(nlayermx)   ! Pressure at the middle of the layers (Pa)
+      REAL plev(nlayermx+1) ! intermediate pressure levels (pa)
+      REAL psurf,tsurf      
+      REAL u(nlayermx),v(nlayermx)  ! zonal, meridional wind
+      REAL gru,grv   ! prescribed "geostrophic" background wind
+      REAL temp(nlayermx)   ! temperature at the middle of the layers
+      REAL q(nlayermx,nqmx) ! tracer mixing ratio (e.g. kg/kg)
+      REAL qsurf(nqmx)      ! tracer surface budget (e.g. kg.m-2)
+      REAL tsoil(nsoilmx)   ! subsurface soik temperature (K)
+!      REAL co2ice           ! co2ice layer (kg.m-2) !not used anymore
+      integer :: i_co2_ice=0  ! tracer index of co2 ice
+      integer :: i_h2o_ice=0  ! tracer index of co2 ice
+      REAL emis             ! surface layer
+      REAL q2(nlayermx+1)   ! Turbulent Kinetic Energy
+      REAL zlay(nlayermx)   ! altitude estimee dans les couches (km)
+
+c    Physical and dynamical tandencies (e.g.  m.s-2, K/s, Pa/s)
+      REAL du(nlayermx),dv(nlayermx),dtemp(nlayermx)
+      REAL dudyn(nlayermx),dvdyn(nlayermx),dtempdyn(nlayermx)
+      REAL dpsurf    
+      REAL dq(nlayermx,nqmx)
+      REAL dqdyn(nlayermx,nqmx)
+
+c   Various intermediate variables
+!      INTEGER thermo
+      REAL zls
+      REAL phi(nlayermx),h(nlayermx),s(nlayermx)
+      REAL pks, ptif, w(nlayermx)
+      REAL qtotinit, mqtot(nqmx),qtot
+      INTEGER ierr, aslun
+      REAL tmp1(0:nlayermx),tmp2(0:nlayermx)
+      Logical  tracerdyn
+      integer :: nq=1 ! number of tracers
+ 
+      character*2 str2
+      character (len=7) :: str7
+
+      logical oldcompare, earthhack,saveprofile
+
+!     added by RW for zlay computation
+      real Hscale, Hmax, rho, dz
+
+!     added by RW for autozlevs computation
+      real nu, xx, pMIN, zlev, Htop
+      real logplevs(nlayermx)
+
+!     added by RDW to allow variations in cp with location
+      REAL cpp3D(ngridmx,nlayermx)   ! specific heat capacity at const. pressure
+      REAL rcp3D(ngridmx,nlayermx)   ! R / specific heat capacity
+      
+!     added by BC
+      REAL cloudfrac(ngridmx,nlayermx)
+      REAL hice(ngridmx),totcloudfrac(ngridmx)
+
+
+c=======================================================================
+
+c=======================================================================
+c INITIALISATION
+c=======================================================================
+
+      saveprofile=.true.
+
+c ------------------------------------------------------
+c  Default values for constants (corresponding to Mars)
+c ------------------------------------------------------
+
+      pi=2.E+0*asin(1.E+0)
+
+c     Constante de la Planete Mars
+c     ----------------------------
+      rad=3397200.               ! rayon de mars (m)  ~3397200 m
+      daysec=88775.              ! duree du sol (s)  ~88775 s
+      omeg=4.*asin(1.)/(daysec)  ! vitesse de rotation (rad.s-1)
+      g=3.72                     ! gravite (m.s-2) ~3.72  
+      mugaz=43.49                ! Masse molaire de l'atm (g.mol-1) ~43.49
+      rcp=.256793                ! = r/cp  ~0.256793
+      r= 8.314511E+0 *1000.E+0/mugaz
+      cpp= r/rcp
+      year_day = 669           ! duree de l'annee (sols) ~668.6
+      periastr = 206.66          ! min. dist. star-planet (Mkm) ~206.66
+      apoastr = 249.22           ! max. dist. star-planet (Mkm) ~249.22
+      peri_day =  485.           ! date du periastron (sols depuis printemps)
+      obliquit = 25.2           ! Obliquite de la planete (deg) ~25.2         
+ 
+c     Parametres Couche limite et Turbulence 
+c     --------------------------------------
+      z0 =  1.e-2                ! surface roughness (m) ~0.01 
+      emin_turb = 1.e-6          ! energie minimale ~1.e-8
+      lmixmin = 30               ! longueur de melange ~100
+ 
+c     propriete optiques des calottes et emissivite du sol
+c     ----------------------------------------------------
+      emissiv= 0.95              ! Emissivite du sol martien ~.95
+      emisice(1)=0.95            ! Emissivite calotte nord
+      emisice(2)=0.95            ! Emissivite calotte sud  
+
+      albedice(1)=0.5            ! Albedo calotte nord
+      albedice(2)=0.5            ! Albedo calotte sud
+      iceradius(1) = 100.e-6     ! mean scat radius of CO2 snow (north)
+      iceradius(2) = 100.e-6     ! mean scat radius of CO2 snow (south)
+      dtemisice(1) = 2.          ! time scale for snow metamorphism (north)
+      dtemisice(2) = 2.          ! time scale for snow metamorphism (south
+      hybrid=.false.
+
+c ------------------------------------------------------
+c  Load parameters from "run.def" 
+c ------------------------------------------------------
+
+! also check if 'run1d.def' file is around (otherwise reading parameters
+! from callphys.def via getin() routine won't work.
+      open(90,file='run.def',status='old',form='formatted',
+     &     iostat=ierr)
+      if (ierr.ne.0) then
+        write(*,*) 'Cannot find required file "run.def"'
+        write(*,*) '  (which should contain some input parameters'
+        write(*,*) '   along with the following line:'
+        write(*,*) '   INCLUDEDEF=callphys.def'
+        write(*,*) '   )'
+        write(*,*) ' ... might as well stop here ...'
+        stop
+      else
+        close(90)
+      endif
+
+! check if we are going to run with or without tracers
+      write(*,*) "Run with or without tracer transport ?"
+      tracer=.false. ! default value
+      call getin("tracer",tracer)
+      write(*,*) " tracer = ",tracer
+
+! while we're at it, check if there is a 'traceur.def' file
+! and preocess it, if necessary. Otherwise initialize tracer names
+      if (tracer) then
+      ! load tracer names from file 'traceur.def'
+        open(90,file='traceur.def',status='old',form='formatted',
+     &       iostat=ierr)
+        if (ierr.eq.0) then
+          write(*,*) "rcm1d: Reading file traceur.def"
+          ! read number of tracers:
+          read(90,*,iostat=ierr) nq
+          if (ierr.ne.0) then
+            write(*,*) "rcm1d: error reading number of tracers"
+            write(*,*) "   (first line of traceur.def) "
+            stop
+          else
+            ! check that the number of tracers is indeed nqmx
+            if (nq.ne.nqmx) then
+              write(*,*) "rcm1d: error, wrong number of tracers:"
+              write(*,*) "nq=",nq," whereas nqmx=",nqmx
+              stop
+            endif
+          endif
+        
+          ! initialize advection schemes to Van-Leer for all tracers
+          do iq=1,nq
+            iadv(iq)=3 ! Van-Leer
+          enddo
+        
+          do iq=1,nq
+          ! minimal version, just read in the tracer names, 1 per line
+            read(90,*,iostat=ierr) tnom(iq)
+            if (ierr.ne.0) then
+              write(*,*) 'rcm1d: error reading tracer names...'
+              stop
+            endif
+          enddo !of do iq=1,nq
+! check for co2_ice / h2o_ice tracers:
+         i_co2_ice=0
+         i_h2o_ice=0
+         do iq=1,nq
+           if (tnom(iq)=="co2_ice") then
+             i_co2_ice=iq
+           elseif (tnom(iq)=="h2o_ice") then
+             i_h2o_ice=iq
+           endif
+         enddo
+         !if (i_co2_ice==0) then
+         !  write(*,*) "rcm1d: error, we need a 'co2_ice' tracer"
+         !  write(*,*) "   (add one to traceur.def)"
+         !  stop
+         !endif
+        else
+          write(*,*) 'Cannot find required file "traceur.def"'
+          write(*,*) ' If you want to run with tracers, I need it'
+          write(*,*) ' ... might as well stop here ...'
+          stop
+        endif
+        close(90)
+
+      else
+      ! we still need to set (dummy) tracer names for physdem1
+        nq=nqmx
+        do iq=1,nq
+          write(str7,'(a1,i2.2)')'q',iq
+          tnom(iq)=str7
+        enddo
+        ! actually, we'll need at least one "co2_ice" tracer
+        ! (for surface CO2 ice)
+        tnom(1)="co2_ice"
+        i_co2_ice=1
+      endif ! of if (tracer)
+
+
+c  Date et heure locale du debut du run
+c  ------------------------------------
+c    Date (en sols depuis le solstice de printemps) du debut du run
+      day0 = 0 ! default value for day0
+      write(*,*) 'Initial date (in martian sols ; =0 at Ls=0)?'
+      call getin("day0",day0)
+      day=float(day0)
+      write(*,*) " day0 = ",day0
+c  Heure de demarrage
+      time=0 ! default value for time
+      write(*,*)'Initial local time (in hours, between 0 and 24)?'
+      call getin("time",time)
+      write(*,*)" time = ",time
+      time=time/24.E+0 ! convert time (hours) to fraction of sol
+
+c  Discretisation (Definition de la grille et des pas de temps)
+c  --------------
+c
+      nlayer=nlayermx
+      nlevel=nlayer+1
+      nsoil=nsoilmx
+
+      day_step=48 ! default value for day_step
+      PRINT *,'Number of time steps per sol ?'
+      call getin("day_step",day_step)
+      write(*,*) " day_step = ",day_step
+
+      ndt=10 ! default value for ndt
+      PRINT *,'Number of sols to run ?'
+      call getin("ndt",ndt)
+      write(*,*) " ndt = ",ndt
+
+      ndt=ndt*day_step     
+      dtphys=daysec/day_step  
+
+
+c Pression de surface sur la planete
+c ------------------------------------
+c
+      psurf=100000. ! default value for psurf
+      PRINT *,'Surface pressure (Pa) ?'
+      call getin("psurf",psurf)
+      write(*,*) " psurf = ",psurf
+c Pression de reference
+      pa=20.
+      preff=610. ! these values are not needed in 1D  
+
+c Gravity of planet
+c -----------------
+      g=10.0 ! default value for g
+      PRINT *,'Gravity ?'
+      call getin("g",g)
+      write(*,*) " g = ",g
+
+      mugaz=0.
+      cpp=0.
+
+      call su_gases
+      call calc_cpp_mugaz
+      
+
+c Proprietes des poussiere aerosol
+c --------------------------------
+      tauvis=0.2 ! default value for tauvis
+      print *,'Reference dust opacity at 700 Pa ?'
+      call getin("tauvis",tauvis)
+      write(*,*) " tauvis = ",tauvis
+ 
+c  latitude/longitude
+c  ------------------
+      lati(1)=0 ! default value for lati(1)
+      PRINT *,'latitude (in degrees) ?'
+      call getin("latitude",lati(1))
+      write(*,*) " latitude = ",lati(1)
+      lati(1)=lati(1)*pi/180.E+0
+      long(1)=0.E+0
+      long(1)=long(1)*pi/180.E+0
+
+c  periastron/apoastron
+c  --------------------
+      periastr=227.94
+      apoastr=227.94 ! default = mean martian values
+      PRINT *,'periastron (in AU) ?'
+      call getin("periastr",periastr)
+      write(*,*) "periastron = ",periastr
+      periastr=periastr*149.598 ! AU to Mkm
+      PRINT *,'apoastron (in AU) ?'
+      call getin("apoastr",apoastr)
+      write(*,*) "apoastron = ",apoastr
+      apoastr=apoastr*149.598 ! AU to Mkm
+
+c  obliquity
+c  ---------
+      obliquit=0.0! default=zero in 1d
+      PRINT *,'obliquity (in AU) ?'
+      call getin("obliquit",obliquit)
+      write(*,*) "obliquity = ",obliquit
+
+c  Initialisation albedo / inertie du sol
+c  --------------------------------------
+      albedodat(1)=0.2 ! default value for albedodat
+      PRINT *,'Albedo of bare ground ?'
+      call getin("albedo",albedodat(1))
+      write(*,*) " albedo = ",albedodat(1)
+
+      inertiedat(1,1)=400 ! default value for inertiedat
+      PRINT *,'Soil thermal inertia (SI) ?'
+      call getin("inertia",inertiedat(1,1))
+      write(*,*) " inertia = ",inertiedat(1,1)
+c
+c  pour le schema d'ondes de gravite
+c  ---------------------------------
+c
+      zmea(1)=0.E+0
+      zstd(1)=0.E+0
+      zsig(1)=0.E+0
+      zgam(1)=0.E+0
+      zthe(1)=0.E+0
+
+c    Initialisation des traceurs
+c    ---------------------------
+
+      DO iq=1,nqmx
+        DO ilayer=1,nlayer
+           q(ilayer,iq) = 0.
+        ENDDO
+      ENDDO
+     
+      DO iq=1,nqmx
+        qsurf(iq) = 0.
+      ENDDO
+
+c   Initialisation speciales "physiq"
+c   ---------------------------------
+c   la surface de chaque maille est inutile en 1D --->
+      area(1)=1.E+0
+
+c   le geopotentiel au sol est inutile en 1D car tout est controle
+c   par la pression de surface --->
+      phisfi(1)=0.E+0
+
+c  "inifis" reproduit un certain nombre d'initialisations deja faites
+c  + lecture des clefs de callphys.def
+c  + calcul de la frequence d'appel au rayonnement
+c  + calcul des sinus et cosinus des longitude latitude
+
+!Mars possible issue with dtphys in input and include!!!
+      CALL inifis(1,llm,day0,daysec,dtphys,
+     .            lati,long,area,rad,g,r,cpp)
+c   Initialisation pour prendre en compte les vents en 1-D
+c   ------------------------------------------------------
+      ptif=2.E+0*omeg*sinlat(1)
+ 
+
+c    vent geostrophique
+      gru=10. ! default value for gru
+      PRINT *,'zonal eastward component of the geostrophic wind (m/s) ?'
+      call getin("u",gru)
+      write(*,*) " u = ",gru
+      grv=0. !default value for grv
+      PRINT *,'meridional northward component of the geostrophic',
+     &' wind (m/s) ?'
+      call getin("v",grv)
+      write(*,*) " v = ",grv
+
+c     Initialisation des vents  au premier pas de temps
+      DO ilayer=1,nlayer
+         u(ilayer)=gru
+         v(ilayer)=grv
+      ENDDO
+
+c     energie cinetique turbulente
+      DO ilevel=1,nlevel
+         q2(ilevel)=0.E+0
+      ENDDO
+
+c  emissivity / surface co2 ice ( + h2o ice??)
+c  -------------------------------------------
+      emis=emissiv ! default value for emissivity
+      PRINT *,'Emissivity of bare ground ?'
+      call getin("emis",emis)
+      write(*,*) " emis = ",emis
+      emissiv=emis ! we do this so that condense_co2 sets things to the right
+                   ! value if there is no snow
+
+      if(i_co2_ice.gt.0)then
+         qsurf(i_co2_ice)=0 ! default value for co2ice
+         print*,'Initial CO2 ice on the surface (kg.m-2)'
+         call getin("co2ice",qsurf(i_co2_ice))
+         write(*,*) " co2ice = ",qsurf(i_co2_ice)
+         IF (qsurf(i_co2_ice).ge.1.E+0) THEN
+            ! if we have some CO2 ice on the surface, change emissivity
+            if (lati(1).ge.0) then ! northern hemisphere
+              emis=emisice(1)
+            else ! southern hemisphere
+              emis=emisice(2)
+            endif
+         ENDIF
+      endif
+
+c  calcul des pressions et altitudes en utilisant les niveaux sigma
+c  ----------------------------------------------------------------
+
+c    Vertical Coordinates
+c    """"""""""""""""""""
+      hybrid=.true.
+      PRINT *,'Hybrid coordinates ?'
+      call getin("hybrid",hybrid)
+      write(*,*) " hybrid = ", hybrid
+
+
+      autozlevs=.false.
+      PRINT *,'Auto-discretise vertical levels ?'
+      call getin("autozlevs",autozlevs)
+      write(*,*) " autozlevs = ", autozlevs
+
+      pceil=100.0 ! Pascals
+      PRINT *,'Ceiling pressure (Pa) ?'
+      call getin("pceil",pceil)
+      write(*,*) " pceil = ", pceil
+
+! Test of incompatibility:
+! if autozlevs used, cannot have hybrid too
+
+      if (autozlevs.and.hybrid) then
+         print*,'Cannot use autozlevs and hybrid together!'
+         call abort
+      endif
+
+      if(autozlevs)then
+         if(kastprof)then
+            Hscale=10.0
+            Hmax=400.0
+         else
+            
+            open(91,file="z2sig.def",form='formatted')
+            read(91,*) Hscale
+            DO ilayer=1,nlayer-2
+               read(91,*) Hmax
+            enddo
+            close(91)
+ 
+         endif
+            
+         print*,'Hmax = ',Hmax,' km'
+         print*,'Auto-shifting Hscale to:'
+!     Hscale = Hmax / log(psurf/100.0)
+         Hscale = Hmax / log(psurf/pceil)
+         print*,'Hscale = ',Hscale,' km'
+         
+! none of this matters if we dont care about zlay
+         
+      endif
+
+      call disvert
+
+         if(.not.autozlevs)then
+            ! we want only the scale height from z2sig, in order to compute zlay
+            open(91,file="z2sig.def",form='formatted')
+            read(91,*) Hscale
+            close(91)
+         endif
+
+!         if(autozlevs)then
+!            open(94,file="Hscale.temp",form='formatted')
+!            read(94,*) Hscale
+!            close(94)
+!         endif
+
+         DO ilevel=1,nlevel
+            plev(ilevel)=ap(ilevel)+psurf*bp(ilevel)
+         ENDDO
+         
+         DO ilayer=1,nlayer
+            play(ilayer)=aps(ilayer)+psurf*bps(ilayer)
+         ENDDO
+         
+
+
+         DO ilayer=1,nlayer
+!     zlay(ilayer)=-300.E+0 *r*log(play(ilayer)/plev(1))
+!     &   /g
+            zlay(ilayer)=-1000.0*Hscale*log(play(ilayer)/plev(1))
+         ENDDO
+
+!      endif
+
+c  profil de temperature au premier appel
+c  --------------------------------------
+      pks=psurf**rcp
+
+c altitude en km dans profile: on divise zlay par 1000
+      tmp1(0)=0.E+0
+      DO ilayer=1,nlayer
+        tmp1(ilayer)=zlay(ilayer)/1000.E+0
+      ENDDO
+      call profile(nlayer+1,tmp1,tmp2)
+
+      tsurf=tmp2(0)
+      DO ilayer=1,nlayer
+        temp(ilayer)=tmp2(ilayer)
+      ENDDO
+      
+
+
+! Initialize soil properties and temperature
+! ------------------------------------------
+      volcapa=1.e6 ! volumetric heat capacity
+      DO isoil=1,nsoil
+         inertiedat(1,isoil)=inertiedat(1,1) ! soil thermal inertia
+         tsoil(isoil)=tsurf  ! soil temperature
+      ENDDO
+
+! Initialize depths
+! -----------------
+      do isoil=0,nsoil-1
+        mlayer(isoil)=2.e-4*(2.**(isoil-0.5)) ! mid-layer depth
+      enddo
+      do isoil=1,nsoil
+        layer(isoil)=2.e-4*(2.**(isoil-1)) ! layer depth
+      enddo
+
+c    Initialisation pour les sorties GRADS dans "g1d.dat" et "g1d.ctl"
+c    ----------------------------------------------------------------
+c    (effectuee avec "writeg1d" a partir de "physiq.F"
+c    ou tout autre subroutine physique, y compris celle ci).
+
+        g1d_nlayer=nlayer
+        g1d_nomfich='g1d.dat'
+        g1d_unitfich=40
+        g1d_nomctl='g1d.ctl'
+        g1d_unitctl=41
+        g1d_premier=.true.
+        g2d_premier=.true.
+
+c  Ecriture de "startfi"
+c  --------------------
+c  (Ce fichier sera aussitot relu au premier
+c   appel de "physiq", mais il est necessaire pour passer
+c   les variables purement physiques a "physiq"...
+
+      call physdem1("startfi.nc",long,lati,nsoilmx,nqmx,
+     &              dtphys,float(day0),
+     &              time,tsurf,tsoil,emis,q2,qsurf,
+     &              area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,
+     &              cloudfrac,totcloudfrac,hice)
+
+c=======================================================================
+c  BOUCLE TEMPORELLE DU MODELE 1D 
+c=======================================================================
+
+      firstcall=.true.
+      lastcall=.false.
+
+      DO idt=1,ndt
+        IF (idt.eq.ndt-day_step-1) then       !test
+         lastcall=.true.
+         call stellarlong(day*1.0,zls)
+         write(103,*) 'Ls=',zls*180./pi
+         write(103,*) 'Lat=', lati(1)*180./pi
+         write(103,*) 'Tau=', tauvis/700*psurf
+         write(103,*) 'RunEnd - Atmos. Temp. File'
+         write(103,*) 'RunEnd - Atmos. Temp. File'
+         write(104,*) 'Ls=',zls*180./pi
+         write(104,*) 'Lat=', lati(1)
+         write(104,*) 'Tau=', tauvis/700*psurf
+         write(104,*) 'RunEnd - Atmos. Temp. File'
+        ENDIF
+
+c    calcul du geopotentiel 
+c     ~~~~~~~~~~~~~~~~~~~~~
+
+        if(nonideal)then
+
+           DO ilayer=1,nlayer
+              call calc_cpp3d(cpp3D(1,ilayer),
+     $             rcp3D(1,ilayer),temp(ilayer),play(ilayer))
+           ENDDO
+
+           DO ilayer=1,nlayer
+
+!              if(autozlevs)then
+!                 s(ilayer)=(play(ilayer)/psurf)**rcp3D(1,ilayer)
+!              else
+                 s(ilayer)=
+     &                (aps(ilayer)/psurf+bps(ilayer))**rcp3D(1,ilayer)
+!              endif
+
+              h(ilayer)=cpp3D(1,ilayer)*temp(ilayer)/(pks*s(ilayer))
+           ENDDO
+
+        else
+           DO ilayer=1,nlayer
+
+!              if(autozlevs)then
+!                 s(ilayer)=(play(ilayer)/psurf)**rcp
+!              else
+                 s(ilayer)=(aps(ilayer)/psurf+bps(ilayer))**rcp
+!              endif
+              !s(ilayer)=(aps(ilayer)/psurf+bps(ilayer))**rcp
+              h(ilayer)=cpp*temp(ilayer)/(pks*s(ilayer))
+           ENDDO
+        endif
+!      DO ilayer=1,nlayer
+!        s(ilayer)=(aps(ilayer)/psurf+bps(ilayer))**rcp
+!        h(ilayer)=cpp*temp(ilayer)/(pks*s(ilayer))
+!      ENDDO
+      phi(1)=pks*h(1)*(1.E+0-s(1))
+      DO ilayer=2,nlayer
+         phi(ilayer)=phi(ilayer-1)+
+     &               pks*(h(ilayer-1)+h(ilayer))*.5E+0
+     &                  *(s(ilayer-1)-s(ilayer))
+
+      ENDDO
+
+c       appel de la physique
+c       --------------------
+
+
+      CALL physiq (1,llm,nqmx,
+     ,     firstcall,lastcall,
+     ,     day,time,dtphys,
+     ,     plev,play,phi,
+     ,     u, v,temp, q,  
+     ,     w,
+C - sorties
+     s     du, dv, dtemp, dq,dpsurf,tracerdyn)
+
+
+c       evolution du vent : modele 1D
+c       -----------------------------
+ 
+c       la physique calcule les derivees temporelles de u et v.
+c       on y rajoute betement un effet Coriolis.
+c
+c       DO ilayer=1,nlayer
+c          du(ilayer)=du(ilayer)+ptif*(v(ilayer)-grv)
+c          dv(ilayer)=dv(ilayer)+ptif*(-u(ilayer)+gru)
+c       ENDDO
+
+c       Pour certain test : pas de coriolis a l'equateur
+c       if(lati(1).eq.0.) then
+          DO ilayer=1,nlayer
+             du(ilayer)=du(ilayer)+ (gru-u(ilayer))/1.e4
+             dv(ilayer)=dv(ilayer)+ (grv-v(ilayer))/1.e4
+          ENDDO
+c       end if
+c      
+c
+c       Calcul du temps au pas de temps suivant
+c       ---------------------------------------
+        firstcall=.false.
+        time=time+dtphys/daysec
+        IF (time.gt.1.E+0) then
+            time=time-1.E+0
+            day=day+1
+        ENDIF
+
+c       calcul des vitesses et temperature au pas de temps suivant
+c       ----------------------------------------------------------
+
+        DO ilayer=1,nlayer
+           u(ilayer)=u(ilayer)+dtphys*du(ilayer)
+           v(ilayer)=v(ilayer)+dtphys*dv(ilayer)
+           temp(ilayer)=temp(ilayer)+dtphys*dtemp(ilayer)
+        ENDDO
+
+c       calcul des pressions au pas de temps suivant
+c       ----------------------------------------------------------
+
+           psurf=psurf+dtphys*dpsurf   ! evolution de la pression de surface
+           DO ilevel=1,nlevel
+              plev(ilevel)=ap(ilevel)+psurf*bp(ilevel)
+           ENDDO
+           DO ilayer=1,nlayer
+                 play(ilayer)=aps(ilayer)+psurf*bps(ilayer)
+           ENDDO
+
+c       calcul traceur au pas de temps suivant
+c       --------------------------------------
+
+        DO iq = 1, nqmx
+          DO ilayer=1,nlayer
+             q(ilayer,iq)=q(ilayer,iq)+dtphys*dq(ilayer,iq)
+          ENDDO
+        END DO
+
+      ENDDO   ! fin de la boucle temporelle
+
+c    ========================================================
+c    GESTION DES SORTIE
+c    ========================================================
+
+c    fermeture pour conclure les sorties format grads dans "g1d.dat"
+c    et "g1d.ctl" (effectuee avec "writeg1d" a partir de "physiq.F"
+c    ou tout autre subroutine physique, y compris celle ci).
+
+! save temperature profile
+      if(saveprofile)then
+         OPEN(12,file='profile.out',form='formatted')
+         DO ilayer=1,nlayermx
+	    write(12,*) temp(ilayer), play(ilayer)
+         ENDDO
+         CLOSE(12)
+      endif
+
+      logplevs(1)=log(plev(1)/100000.0)
+      do ilayer=2,nlayer
+         logplevs(ilayer)=log(play(ilayer)/100000.0)
+      enddo
+      CALL endg1d(1,nlayer,logplevs,ndt) ! now simply log(p) with p in bars
+
+c    ========================================================
+      end                       !rcm1d
+ 
+c***********************************************************************
+c***********************************************************************
+c     Subroutines Bidons utilise seulement en 3D, mais
+c     necessaire a la compilation de rcm1d en 1D
+
+      subroutine gr_fi_dyn
+      RETURN
+      END
+ 
+c***********************************************************************
+c***********************************************************************
+
+#include "../dyn3d/disvert.F"
Index: /trunk/LMDZ.GENERIC/libf/phystd/setspi.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/setspi.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/setspi.F90	(revision 253)
@@ -157,4 +157,5 @@
       ! force planck=sigma*eps*T^4 for each temperature in array
       if(forceEC)then
+         print*,'Force F=sigma*eps*T^4 for all values of T!'
          do nt=NTstar,NTstop
             plancksum=0.0
Index: /trunk/LMDZ.GENERIC/libf/phystd/setspv.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/setspv.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/setspv.F90	(revision 253)
@@ -110,5 +110,5 @@
 
       write(*,*)'Interpolating stellar spectrum from the hires data...'
-      call ave_stelspec(startype,STELLAR)
+      call ave_stelspec(STELLAR)
 
 !     Sum the stellar flux, and write out the result.  
@@ -120,4 +120,5 @@
       write(6,'(" Stellar flux at 1 AU = ",f7.2," W m-2")') sum
       print*,' '
+
 
 !=======================================================================
Index: /trunk/LMDZ.GENERIC/libf/phystd/sfluxi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/sfluxi.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/sfluxi.F	(revision 253)
@@ -32,5 +32,5 @@
       real*8 taugsurf(L_NSPECTI,L_NGAUSS-1), fzero
 
-      real*8 BSURFtest ! by RW for test
+!      real*8 BSURFtest ! by RW for test
 
       real*8 fup_tmp(L_NSPECTI),fdn_tmp(L_NSPECTI)
@@ -45,4 +45,5 @@
     
       NFLUXTOPI = 0.0
+
       DO NW=1,L_NSPECTI
         NFLUXTOPI_nu(NW) = 0.0
@@ -68,8 +69,10 @@
       TSURF = TLEV(L_LEVELS)
 
-      NTS   = TSURF*10.0D0-499
-      NTT   = TTOP *10.0D0-499
+      NTS   = int(TSURF*10.0D0)-NTstar+1
+      NTT   = int(TTOP *10.0D0)-NTstar+1
+!      NTS   = TSURF*10.0D0-499
+!      NTT   = TTOP *10.0D0-499
 
-      BSURFtest=0.0
+!      BSURFtest=0.0
 
       DO 501 NW=1,L_NSPECTI
@@ -78,11 +81,4 @@
         BSURF = (1.-RSFI)*PLANCKIR(NW,NTS) ! interpolate for accuracy??
         PLTOP = PLANCKIR(NW,NTT)
-
-        !BSURFtest=BSURFtest+BSURF*DWNI(NW)
-        !if(NW.eq.L_NSPECTI)then
-        !     print*,'eps*sigma*T^4',5.67e-8*(1.-RSFI)*TSURF**4
-        !     print*,'BSURF in sfluxi=',pi*BSURFtest
-        !endif
-
 
 C  If FZEROI(NW) = 1, then the k-coefficients are zero - skip to the
@@ -116,4 +112,5 @@
 
 
+
 C         NOW CALCULATE THE CUMULATIVE IR NET FLUX
 
@@ -137,16 +134,9 @@
      *                                (1.0-FZEROI(NW))
 
-
 c         and same thing by spectral band... (RW)
             FLUXUPI_nu(L,NW) = FLUXUPI_nu(L,NW) + 
      *                FMUPI(L)*DWNI(NW)*GWEIGHT(NG)*(1.0-FZEROI(NW))
 
-
           END DO
-
-         !fup_tmp(nw)=fup_tmp(nw)+FMUPI(L_NLEVRAD-1)*DWNI(NW)*GWEIGHT(NG)
-         !fdn_tmp(nw)=fdn_tmp(nw)+FMDI(L_NLEVRAD-1)*DWNI(NW)*GWEIGHT(NG)
-         !fup_tmp(nw)=fup_tmp(nw)+FMUPI(1)*DWNI(NW)*GWEIGHT(NG)
-         !fdn_tmp(nw)=fdn_tmp(nw)+FMDI(1)*DWNI(NW)*GWEIGHT(NG)
 
    30     CONTINUE
@@ -154,16 +144,7 @@
        END DO       !End NGAUSS LOOP
 
-           ! print*,'-----------------------------------'
-            !print*,'FMDI(',nw,')=',FMDI(L_NLEVRAD-1)
-            !print*,'FMUPI(',nw,')=',FMUPI(L_NLEVRAD-1)
-            !print*,'DWNI(',nw,')=',DWNI(nw)
-           ! print*,'-----------------------------------'
-
    40  CONTINUE
 
 C      SPECIAL 17th Gauss point
-
-    !   print*,'fzero for ng=17',fzero
-
 
        NG     = L_NGAUSS
@@ -203,27 +184,8 @@
        END DO
 
-       !     print*,'-----------------------------------'
-       !     print*,'nw=',nw
-       !     print*,'ng=',ng
-       !     print*,'FMDI=',FMDI(L_NLEVRAD-1)
-       !     print*,'FMUPI=',FMUPI(L_NLEVRAD-1)
-       !     print*,'-----------------------------------'
-
   501 CONTINUE      !End Spectral Interval LOOP
 
 C *** END OF MAJOR SPECTRAL INTERVAL LOOP IN THE INFRARED****
 
-            !print*,'-----------------------------------'
-            !print*,'gweight=',gweight
-            !print*,'FLUXDNI=',FLUXDNI(L_NLEVRAD-1)
-            !print*,'FLUXUPI=',FLUXUPI(L_NLEVRAD-1)
-            !print*,'-----------------------------------'
-
-            !do nw=1,L_NSPECTI
-            !   print*,'fup_tmp(',nw,')=',fup_tmp(nw)
-            !   print*,'fdn_tmp(',nw,')=',fdn_tmp(nw)
-            !enddo
-
-
       RETURN
       END
